/*
oop_ex102.cpp
Multiple Inheritance
*/


#include <iostream>
#include <string>

using namespace std;


class Staff
{
private:
	string dept;
protected:
	string name;
	double salary;
public:
	Staff(string n,string d, double s)
	{
		name =n;
		dept = d;
		salary = s;
	}

	void setDept(string d) { dept = d; }
	string getDept() { return dept; }

	void print()
	{
		cout << "Staff name = " << name << endl;
		cout << ",who works in " << dept << " ";
		cout << ",whose salary is " << salary << endl << endl;
	}
};


class Student
{
private:
	string dept;
protected:
	string name;
	string level;
public:
	Student(string n, string d, string l)
	{
		name = n;
		dept = d;
		level = l;
	}

	void setDept(string d) {dept = d; }
	string getDept() { return dept; }

	void print()
	{
		cout << "Student name = " << name << endl;
		cout << ",who studies in " << dept << " ";
		cout << ",whose level is " << level << endl << endl;
	}
};


class TA : public Staff, public Student
{
private:
	string course;
public:
	TA(string n,string wd, double s,string sd,string l,string c)
		: Staff(n, wd, s), Student(n, sd, l)
	{
		course = c;
	}

	void setCourse(string c) {  course = c; }
	string getCourse() { return course; }

	void print()
	{
		//cout<<"TA name = " << name <<endl;  //'name' is ambiguous
		cout << "TA name = " << Student::name << endl;

		//cout<<",who is in = " << getDept() <<endl;	  //'getDept()' is ambiguous
		cout << ",who studies in " << Student::getDept() << " ";
		cout << ",whose level is " << level << endl;

		cout << ",who works in " << Staff::getDept() << " ";
		cout << ",whose salary is " << salary << " ";
		cout << ",who works for course " << course << endl << endl;
	}
};

void main()
{
	Staff p1("John", "ME", 10000);
	Student p2("Mike", "CS", "Senior");
	TA p3("Paul", "CT", 6000, "AD", "PhD", "CT5706");

	p1.print();
	p2.print();
	p3.print();

	Staff* ptr1 = &p3;		 //TA is a Staff
	Student* ptr2 = &p3;	 //TA is a Student, too
	TA* ptr3 = (TA*)ptr1; //downcasting 

	ptr1->print();
	ptr2->print();
	ptr3->print();	  //p3 is a TA, OK
	
	system("pause");
}