/*
oop_ex96.cpp
Protected members
*/

#include <iostream>
#include <math.h>

using namespace std;

// The point base class
class point
{
protected:
	double x;
	double y;
public:
	point();
	point(double xx, double yy);
	~point() { /*cout<<"~point() for x = "<<x<<" y = "<<y<<endl;*/ }

	//double getX(){return x;}
	//double getY(){return y;}

	void moveTo(double xx, double yy);
	double distTo(double xx, double yy);
	void print();
};

point::point()
{
	//cout<<"point::point()"<<endl;
	x = 0.0;
	y = 0.0;
}

point::point(double xx, double yy)
{
	//cout<<"point::point(double xx, double yy)"<<endl;
	x = xx;
	y = yy;
}

void point::moveTo(double xx, double yy)
{
	x = xx;
	y = yy;
}

double point::distTo(double xx, double yy)
{
	double dx = x - xx;
	double dy = y - yy;

	return sqrt(dx*dx + dy * dy);
}

void point::print()
{
	cout << "x = " << x << ", ";
	cout << "y = " << y << endl;
}


// The circle derived class
class circle : public point
{
	double radius;
public:
	circle();
	circle(double r);
	circle(double xx, double yy, double r);
	~circle() { /*cout<<"~circle() for radius = "<< radius <<endl;*/ }

	// overridden function
	void print();

	// new function members
	double area();
	double perimeter();
	void setR(double r) { radius = r; }
	double getR() { return radius; }
};


// constructors
circle::circle() //: point()	 //call a constructor of base class
{
	//cout<<"circle::circle()"<<endl;
	x = 0.0;
	y = 0.0;
	radius = 0.0;
}

circle::circle(double r) //: point()
{
	//cout<<"circle::circle(double r)"<<endl;
	x = 0.0;
	y = 0.0;
	radius = r;
}

circle::circle(double xx, double yy, double r)// : point(xx, yy)
{
	cout << "circle::circle(double xx, double yy, double r)" << endl;
	x = xx;
	y = yy;
	radius = r;
}


// overridden function
void circle::print()
{
	//1. OK, access protected members of base class
	cout << "x = " << x << ", ";
	cout << "y = " << y << endl;


	//2. OK, calling the original function in base class
	//point::print();

	cout << "radius = " << radius << " ";
	cout << "area = " << area() << " ";
	cout << "perimeter = " << perimeter() << endl;
}


// new function members
double circle::area()
{
	return 3.14159*radius*radius;
}

double circle::perimeter()
{
	return 2 * 3.14159*radius;
}





void main()
{
	point p1(3, 4);
	circle c1(30, 40, 5);


	cout << "-------------------" << endl;
	p1.print();
	cout << "-------------------" << endl;
	c1.print();
	cout << "-------------------" << endl;

	//cout<<p1.x<<endl;
	//cout<<p1.y<<endl;
	
	system("pause");
}


