// oop_ex98.cpp: protected inheritance in C++.

#include <iostream>

using namespace std;

class vector
{
private:
	double x;
protected:
	double y;
public:
	double z;

	void setData(double xx, double yy, double zz)
	{
		x = xx;
		y = yy;
		z = zz;
	}

	void print()
	{
		cout << "x = " << x << endl;
		cout << "y = " << y << endl;
		cout << "z = " << z << endl << endl;
	}
};

class subvector : protected vector
{
public:
	void setData(double xx, double yy, double zz)
	{
		//x = xx;		//x is hidden
		y = yy;		//y is protected
		z = zz;		//z is protected
	}

	void print()
	{
		//cout<<"x = " << x <<endl;
		cout << "y = " << y << endl;
		cout << "z = " << z << endl << endl;
	}
};

class subsubvector : protected subvector
{
public:
	void setData(double xx, double yy, double zz)
	{
		//x = xx;		//x is hidden
		y = yy;		//y is protected
		z = zz;		//z is protected
	}

	void print()
	{
		//cout<<"x = " << x <<endl;
		cout << "y = " << y << endl;
		cout << "z = " << z << endl << endl;
	}
};

void main()
{
	cout << "vector v1:" << endl;
	vector v1;
	v1.setData(10, 10, 10);
	v1.print();

	//v1.x = 20;	//x is private
	//v1.y = 20;	//y is protected
	v1.z = 20;		//z is public	
	v1.print();

	//--------------------
	cout << "subvector v2:" << endl;
	subvector v2;
	v2.setData(30, 30, 30);
	v2.print();

	//v2.x = 40;	//x is private(hidden)
	//v2.y = 40;	//y is protected
	//v2.z = 40;	//z is protected		
	v2.print();

	//!! subvector is not a vector	
	//vector* vptr1 = &v2;

	//--------------------
	cout << "subsubvector v3:" << endl;
	subsubvector v3;
	v3.setData(50, 50, 50);
	v3.print();

	//v3.x = 60;	//x is private(hidden)
	//v3.y = 60;	//y is protected
	//v3.z = 60;	//z is protected		
	v3.print();

	//!! subsubvector is not a vector	
	//vector* vptr2 = &v3;

	system("pause");
}